<?php

namespace Drupal\commerce_payu_webcheckout\PluginForm;

use Drupal\commerce_payment\PluginForm\PaymentMethodAddForm;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Entity\Entity\EntityFormDisplay;
use Drupal\profile\Entity\Profile;

/**
 * Class that defines billing form.
 */
class PayuAddForm extends PaymentMethodAddForm {

  /**
   * {@inheritdoc}
   */
  protected function buildBillingProfileForm(array $element, FormStateInterface $form_state) {
    /** @var \Drupal\commerce_payment\Entity\PaymentMethodInterface $payment_method */
    $payment_method = $this->entity;
    $profiles = \Drupal::entityTypeManager()->getStorage('profile')->loadByProperties(array(
      'type' => 'customer',
      'uid' => $payment_method->getOwnerId(),
      'is_default' => TRUE,
    ));
    if ($profiles) {
      // There is a default profile for this user.
      $billing_profile = reset($profiles);
    }
    else {
      $billing_profile = Profile::create(array(
        'type' => 'customer',
        'uid' => $payment_method->getOwnerId(),
      ));
    }
    $form_display = EntityFormDisplay::collectRenderDisplay($billing_profile, 'default');
    $form_display->buildForm($billing_profile, $element, $form_state);
    // Remove the details wrapper from the address field.
    if (!empty($element['address']['widget'][0])) {
      $element['address']['widget'][0]['#type'] = 'container';
    }
    // Store the billing profile for the validate/submit methods.
    $element['#entity'] = $billing_profile;

    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $this->submitBillingProfileForm($form['billing_information'], $form_state);
  }

}
